Rem Build Version: 3.0.104.0
@echo off
REM ***********************************************************************
REM THIS CODE AND INFORMATION IS PROVIDED TO YOU FOR YOUR REFERENTIAL 
REM PURPOSES ONLY, AND IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
REM EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED 
REM WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE, 
REM AND MAY NOT BE REDISTRIBUTED IN ANY MANNER.
REM 
REM Copyright (c) 2003 - 2004  Microsoft Corporation.  All rights reserved.
REM ***********************************************************************

REM Verify CommandLine Parameters
if {%1}=={} echo NO MODE ARGUMENT SUPPLIED&Call :Help &goto :TheEnd
REM ================ Edit Configuration Settings here ! ====================================
REM make sure no quotes are at the end of the paths!

SET SETUPPATH="\\computer\share\
SET STSADMINPATH="C:\Program Files\Common Files\Microsoft Shared\web server extensions\60\BIN\
SET SQLSERVER=SQLBE01
SET CONFIGDBNAME=HostedSharePoint_CONFIG
SET VSURL=http://%COMPUTERNAME%
SET CONTENTDBNAME=HostedSharePoint_CONTENT
SET OWNERLOGIN=fabrikam\Administrator
SET OWNERMAIL=Administrator@fabrikam.com
SET OWNERNAME="Service Provider Admin"
SET APPID=HostedSharePoint_APP
SET APPUSER=SharePoint_AppID
SET APPPWD=Pass1Word
SET ADMINPORT=8181
SET STEP=0

REM ================ End of Configuration Settings ====================================

echo Configuration Settings for Windows Sharepoint Services Installation:
echo ----------------------------------------------------------------------------
echo SETUPPATH = %SETUPPATH%
echo STSADMINPATH = %STSADMINPATH%
echo SQLSERVER = %SQLSERVER%
echo CONFIGDBNAME = %CONFIGDBNAME%
echo VSURL = %VSURL%
echo CONTENTDBNAME = %CONTENTDBNAME%
echo OWNERLOGIN = %OWNERLOGIN%
echo OWNERMAIL = %OWNERMAIL%
echo OWNERNAME = %OWNERNAME%
echo APPID = %APPID%
echo APPUSER = %APPUSER%
echo APPPWD = %APPPWD%
echo ADMINPORT = %ADMINPORT%

echo 
echo are the above settings correct? Then hit Enter to Continue.
echo if not Type CTRL+C to abort and edit the Batch File.
echo 
Pause > Nul

GOTO %STEP%

:0
REM Get the current batch file's short path
for %%x in (%0) do set MainBatchPath=%%~dpsx
for %%x in (%MainBatchPath%) do set MainBatchPath=%%~dpsx
echo MainBatchPath = %MainBatchPath%
echo Hosted Sharepoint Setup Files are at %SETUPPATH%

REM Configure Prerequesites
echo Now starting Configuration of Server Prerequesites
echo if asked for Windows Server Source Files please
echo enter the Path to the i386 Directory
SET STEP=1

:1
REM Install IIS Using the Solution Batch Files
echo Configuring IIS
Call %MainBatchPath%IIS\IIS.CMD IIS.CMD ON C:
SET STEP=2

:2
REM Configure ASP.NET Using the Solution Batch Files
echo configuring ASP.NET
Call %MainBatchPath%IIS\ASPNET.CMD ASPNET.CMD ON
SET STEP=3

:3
REM Remove FPSE Prior to installing Windows Sharepoint Services
REM Using the Solution Batch Files
echo remove FrontPage Server Extensions
Call %MainBatchPath%IIS\FPSE.CMD FPSE.CMD OFF
SET STEP=4

:4
REM Now run Windows SharePoint Service
REM Setup with the apropriate Command Line
REM the Environment Variable %SETUPPATH% must point
REM to the Directory where the Windows Sharepoint Services
REM Setup FIles reside.
REM you need to unpack the STSV2.EXE File using the /C /T:<Path> 
REM Commandline Switches to create the Install Directory!

echo Starting Windows Sharepoint Services Setup in Server Farm Mode
echo from %SETUPPATH% please make sure the Path set
echo above is correct!
echo follow the wizard by accepting the defaults.
echo when the Administration site comes up Do Nothing and hit ENTER
echo in the CommandPrompt when asked for it!
REM Make sure the Windows Sharepoint Services
REM Setup File Exists
REM if Not Bail out
If NOT exist %SETUPPATH%SETUPSTS.EXE" Goto NOSETUP
REM now launch the Setup 
%SETUPPATH%SETUPSTS.EXE" REMOTESQL=YES
SET STEP=5

REM Need to wait here until Setup is done because the setup returns early
echo Please hit Enter when the Setup Process has completed.
pause >NULL

:5
REM Configure the Admin Port for the Windows Sharepoint Services
REM Central Admin Pages. This must be the same Port on all Frontends
REM create the Application Pool Identity User in the Domain
echo Creating User for Application Pool
net user /domain /add %APPUSER% %APPPWD%
REM Since this user is also used to run the SPTimer Service on the Windows SharePoint Services Server
REM it needs the LogOn as a Service right
REM STSADM.EXE does not grant this Right automatically (The Admin Pages do)
REM Check for NTRIGHTS.EXE from the Windows Resource Kit
echo Checking for Windows Resource Kit
if  exist "C:\Program Files\Windows Resource Kits\Tools\NTRIGHTS.EXE" Goto SetRights
Goto PopMMC

:PopMMC
REM open Local Security Policy MMC
echo The Windows Resource Kit was not found. Opening Policy Console ...
echo Please Browse to Local Policies/User Rights Assignment and
echo grant the %USERDOMAIN%\%APPUSER% Account the 'Logon as a Service Priviliege'
echo when done hit ENTER to continue the Setup Process.
%SystemRoot%\system32\secpol.msc /s
pause > NULL
Goto SetPort

:SetRights
REM Grant the SeServiceLogonRight for the STSSVC Account
echo Granting Logon as a Service Privilege
NTRIGHTS -u %USERDOMAIN%\%APPUSER% +r SeServiceLogonRight
REM Reload the policy
GPUpdate /Target:Computer /Force
REM Wait a little for the Policy to be refreshed
echo We need to wait at least 60 seconds fot the refresh to complete
echo otherwise the SPTimer Service will not start!c	
echo Hit Enter after approximately 60 Seconds
Time /T
Pause >NULL
REM Add the new User to the IIS_WPG Group to ensure it has access to the ASP.NET Temp Files
REM This might not be necesarry because it is added by Sharepooint to the STS_WPG Group too at the next step
net localgroup IIS_WPG %USERDOMAIN%\%APPUSER% /add
Goto SetPort

:SetPort
echo Configuring Administration Website
%STSADMINPATH%stsadm.exe" -o setadminport -port %ADMINPORT% -admapcreateNew -admapidname %APPID%_ADM -admapidtype ConfigurableID -admapidlogin %USERDOMAIN%\%APPUSER% -admapidpwd %APPPWD% 
REM Reset IIS for the Changes to take effect
IISRESET /Timeout:0
SET STEP=6

:6
if %~1 == connect goto connect
if %~1 == Connect goto connect
if %~1 == CONNECT goto connect
goto create

:create
REM Setup the Configuration DB
REM if you do not want to use HostHeader Mode 
REM remove the -hh paramater from the commandline below.
echo Setup a Configuration DB for the Windows Sharepoint Services Server
%STSADMINPATH%stsadm.exe" -o setconfigdb -ds %SQLSERVER%  -dn %CONFIGDBNAME% -hh
goto done6

:connect
echo Connect to the Configuration DB for the Windows Sharepoint Services Server
%STSADMINPATH%stsadm.exe" -o setconfigdb -ds %SQLSERVER%  -dn %CONFIGDBNAME% -connect
goto done6

:done6
SET STEP=7

:7
REM Extend the Virtual Server for the Host HEader Sites
echo Extend Virtual Server with Windows Sharepoint Services 2.0 
echo and create an empty content Database

%STSADMINPATH%stsadm.exe" -o extendvs -url %VSURL% -ds %SQLSERVER% -dn %CONTENTDBNAME% -ownerlogin %OWNERLOGIN% -owneremail %OWNERMAIL% -ownername %OWNERNAME% -donotcreatesite -apcreatenew -apidname %APPID% -apidtype ConfigurableID -apidlogin %USERDOMAIN%\%APPUSER% -apidpwd %APPPWD%

REM Reset IIS for the Changes to take effect
IISRESET /Timeout:0

SET STEP=99
:99
echo All Done you can now run the creathhsite.cmd to create Customer Sites
Echo Press Any Key to Exit this Program
pause >NULL
Goto TheEnd

:NOSETUP
echo Windows Sharepoint Services Setup Files not found at %SETUPPATH%
echo make sure you have the path configured correctly and restart the Installation
Goto TheEnd

:Help
echo USAGE: %~n0 "create|connect"
echo create creates the first Front End Server and configures the Configuration Database
echo connect connects an additional Front End Server to an existing Configuration Database
goto :eof

:TheEnd
